import { FC, ReactNode, MouseEvent, ButtonHTMLAttributes } from "react";
import { type VariantProps } from "class-variance-authority";
declare const button: (props?: ({
    backgroundColor?: "primary" | "secondary" | "warning" | "danger" | "purple" | "darkPurple" | "brown" | "darkGreen" | "darkBlue" | null | undefined;
    color?: "primary" | "secondary" | null | undefined;
    size?: "default" | "small" | null | undefined;
} & import("class-variance-authority/dist/types").ClassProp) | undefined) => string;
export interface ButtonProps extends ButtonHTMLAttributes<HTMLButtonElement>, VariantProps<typeof button> {
    onClick?: (e?: MouseEvent<HTMLButtonElement>) => void;
    children: ReactNode;
    type?: "button" | "submit" | "reset";
    loading?: boolean;
    disabled?: boolean;
    name?: string;
    hasVerticalSpace?: boolean;
    backgroundColor?: "primary" | "secondary" | "warning" | "danger" | "purple" | "darkPurple" | "brown" | "darkGreen" | "darkBlue";
    color?: "primary" | "secondary";
    width?: string;
    size?: "small" | "default";
}
export declare const Button: FC<ButtonProps>;
export {};
