import { jsx } from 'react/jsx-runtime';
import { cva } from 'class-variance-authority';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

var LoaderSpinner = function (_a) {
    var _b = _a.width, width = _b === void 0 ? "8rem" : _b, _c = _a.height, height = _c === void 0 ? "8rem" : _c;
    return (jsx("div", __assign({ style: { width: width, height: height }, className: "inline-block animate-spin rounded-full border-4 border-solid border-current border-e-transparent align-[-0.125em] text-neutral-50 motion-reduce:animate-[spin_1.5s_linear_infinite]", role: "status" }, { children: jsx("span", __assign({ className: "!absolute !-m-px !h-px !w-px !overflow-hidden !whitespace-nowrap !border-0 !p-0 ![clip:rect(0,0,0,0)]" }, { children: "Loading..." })) })));
};

var button = cva("data-[state=true]:mb-2.5 duration-500 opacity-100 disabled:opacity-50 hover:opacity-80  hover:shadow-md justify-center gap-x-1 font-normal flex bg-button-pattern items-center disabled:(!bg-[#c7c7c7] !border-[#c7c7c7]) disabled:cursor-not-allowed cursor-pointer mx-2.5 border-solid border-1 ", {
    variants: {
        backgroundColor: {
            primary: "bg-[#5db2ff] border-[#5db2ff]",
            secondary: "bg-[#53a93f] border-[#53a93f]",
            warning: "bg-[#ef6c00] border-[#ef6c00]",
            danger: "bg-[#ed4e2a] border-[#ed4e2a]",
            purple: "bg-[#8C44A2] border-[#8C44A2]",
            darkPurple: "bg-[#69257e] border-[#69257e]",
            brown: "bg-[#C97F55] border-[#C97F55]",
            darkGreen: "bg-[#157004] border-[#157004]",
            darkBlue: "bg-[#2772ab] border-[#2772ab]",
        },
        color: {
            primary: "text-white",
            secondary: "text-black",
        },
        size: {
            default: ["text-sm rounded-sm px-3 py-2 min-w-12 h-[33px]"],
            small: ["text-xs rounded py-[3px] my-1 px-[7px] min-w-8  h-[22px]"],
        },
    },
    defaultVariants: {
        size: "default",
        backgroundColor: "primary",
        color: "primary",
    },
});
var Button = function (_a) {
    var backgroundColor = _a.backgroundColor, size = _a.size, color = _a.color, _b = _a.width, width = _b === void 0 ? "fit-content" : _b, _c = _a.onClick, onClick = _c === void 0 ? function () { } : _c, children = _a.children, type = _a.type, loading = _a.loading, disabled = _a.disabled, name = _a.name, hasVerticalSpace = _a.hasVerticalSpace;
    return (jsx("button", __assign({ className: button({ backgroundColor: backgroundColor, color: color, size: size }), style: { width: width }, onClick: onClick, type: type, disabled: disabled, id: name, "data-state": hasVerticalSpace }, { children: loading ? jsx(LoaderSpinner, { width: "15px", height: "15px" }) : children })));
};

export { Button };
//# sourceMappingURL=index.esm.js.map
